#include "FLoader.h"

//**Loads from a file and puts each line in the class' vector
bool FLoader::loadFromFile(char filename[]){
	int i;
	string line; //temporary string
	ifstream myfile(filename);
	//load the contents of the file
	if(!myfile){
		cout << "file not found\n";
		return false;
	}
	for(i=0; myfile.good(); i++){
		getline(myfile, line);
		v.push_back(line);//put each line into the vector
			buffer_size++;
	}
	myfile.close(); //close the file
	return true;
}


//**returns 0 if the line contains the name, 1 if
//**it contains the number, 2 if it contains a comment
int FLoader::isNumber(int pos){
	int charPos = v[pos].findOffset(':');
	if( charPos == 4)
		return 0;
	if(charPos == 12)
		return 1;
	//if(charPos == -1)
	return 2;
}

//**calls the appropriate routine to handle the
//**line under process
void FLoader::extractInfo(){
	int i;
	for(i=0; i<v.size(); i++){
		int temp = isNumber(i);
		if(temp == 0){
			cout << i << " HandleName()\n";
			handleName(i);
			lines_processed++;
		}
		if(temp == 1){
			handleNumber(i);
			cout << i << " handleNumber()\n";
		}
		if(temp == 2){
			cout << i << " comment left untouched\n";
		}
	}
	lines_processed = 0;
}

//**displays the contents of the entire vector
void FLoader::displayContents(){
	for(int i=0; i<v.size(); i++){
		v[i].show();
		cout << "\n";
	}
	cout << "size = " << v.size() << "\n";
}

//**Extract the number from the line and put it into
//**the vector
void FLoader::handleNumber(int pos){
	int i, j=0; float temp;
	int lineSize = v[pos].retSize();
	
	char p[lineSize - 12];
	for(i=13; i<lineSize; i++){
		p[j] = v[pos].retChar(i);
		j++;
	}
	temp = atof(p); //make it float
	cout << temp << " goes to slot: " << lines_processed << "\n";
	bank[lines_processed].setdepos(temp); //put the number
}

//**Extract the name from the line and put it into
//**the vector
void FLoader::handleName(int pos){
	int i, j=0;
	int lineSize = v[pos].retSize();
	
	char p[lineSize - 4];
	for(i=5; i<lineSize; i++){
		p[j] = v[pos].retChar(i);
		j++;
	}
	p[j]='\0'; //remotely add the finishing character
	bank.push_back(p);
}

//**this will clean the vector from unnesessary comments
void FLoader::cleanupVector(){
	int i = 0;
	int vectorSize = v.size();
	do{
		if(!v[i].containsVariable()){
			cout << "position " << i << " does not contain"
			"any variable\n";
			vector<FString>::iterator alpha;
			alpha = v.begin();
			alpha = alpha + i;
			v.erase(alpha);
			
			vectorSize--; //decrease the vector's size number
						  //to match its new state
		}
		else
			i++;
	}while(i<vectorSize);
}